Mojolicious::Plugin::JSONConfig(3)

NAME
Mojolicious::Plugin::JSONConfig - JSON configuration plugin

SYNOPSIS
  # myapp.json (it's just JSON with embedded Perl)
  {
    %# Just a value
    "foo": "bar",

    %# Nested data structures are fine too
    "baz": ["♥"],

    %# You have full access to the application
    "music_dir": "<%= app->home->child('music') %>"
  }

  # Mojolicious
  my $config = $app->plugin('JSONConfig');
  say $config->{foo};

  # Mojolicious::Lite
  my $config = plugin 'JSONConfig';
  say $config->{foo};

  # foo.html.ep
  %= $config->{foo}

  # The configuration is available application-wide
  my $config = app->config;
  say $config->{foo};

  # Everything can be customized with options
  my $config = plugin JSONConfig => {file => '/etc/myapp.conf'};

DESCRIPTION
Mojolicious::Plugin::JSONConfig is a JSON configuration plugin that preprocesses its input with Mojo::Template.

The application object can be accessed via $app or the "app" function. A default configuration filename in the application home directory will be generated from the value of "moniker" in Mojolicious ("$moniker.json"). You can extend the normal configuration file "$moniker.json" with "mode" specific ones like "$moniker.$mode.json", which will be detected automatically.

If the configuration value "config_override" has been set in "config" in Mojo when this plugin is loaded, it will not do anything.

The code of this plugin is a good example for learning to build new plugins, you're welcome to fork it.

See "PLUGINS" in Mojolicious::Plugins for a list of plugins that are available by default.

OPTIONS
Mojolicious::Plugin::JSONConfig inherits all options from Mojolicious::Plugin::Config and supports the following new ones.

  template
  # Mojolicious::Lite
  plugin JSONConfig => {template => {line_start => '.'}};

Attribute values passed to Mojo::Template object used to preprocess configuration files.

METHODS
Mojolicious::Plugin::JSONConfig inherits all methods from Mojolicious::Plugin::Config and implements the following new ones.

  parse
  $plugin->parse($content, $file, $conf, $app);

Process content with "render" and parse it with Mojo::JSON.

  sub parse {
    my ($self, $content, $file, $conf, $app) = @_;
    ...
    $content = $self->render($content, $file, $conf, $app);
    ...
    return $hash;
  }

  register
  my $config = $plugin->register(Mojolicious->new);
  my $config = $plugin->register(Mojolicious->new, {file => '/etc/foo.conf'});

Register plugin in Mojolicious application and merge configuration.

  render
  $plugin->render($content, $file, $conf, $app);

Process configuration file with Mojo::Template.

  sub render {
    my ($self, $content, $file, $conf, $app) = @_;
    ...
    return $content;
  }

SEE ALSO
Mojolicious, Mojolicious::Guides, <http://mojolicious.org>.